"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var repo_1 = require("./class/repo");
var index_1 = require("./services/index");
var consts_1 = require("./consts");
var urlReg = /^http[s]?:\/\/.+\.com$/;
var Yuque = /** @class */ (function () {
    function Yuque(token, option) {
        if (option === void 0) { option = {}; }
        var url = option.url || consts_1.DEFAULT_YUQUE_URL;
        if (!urlReg.test(url)) {
            throw Error('输入的语雀地址不正确');
        }
        this.url = url;
        this.token = token;
        this.request = new index_1.default(url, token);
    }
    Yuque.prototype.repo = function (key) {
        return new repo_1.default(key, this.request);
    };
    return Yuque;
}());
exports.default = Yuque;
